#ifndef ASYM_GRID_H
#define ASYM_GRID_H
#include "Box.h"
#include<vector>
namespace Asym{
	//ϸ2d gridӦеԪ֮ļͬģڵУ
	//ûôҪֻҪԪ֮Ϳˣͻкܶgrid
	// "A  A     A  A"ϸgrid壬ôӦgrid,Ϊ2A͵3A֮ļĲͬ
	//ʹö壬reviewerҲЩʣͦ
	//ضgridһϸĶ
	class Grid{
		std::vector<std::vector<std::vector<int>>> matrix;
	public:

		Grid(int r,int c){
			matrix.resize(r);
			for(int i=0;i<r;++i)
				matrix[i].resize(c);
		}

		std::vector<int>& operator()(int r,int c){
			return matrix[r][c];
		}

		bool operator==(const Grid& ) ;

		void copyRowsToEnd(int startRow,int num);
		void copyColsToEnd(int startCol,int num);
		void removeBackRows(int num);
		void removeBackCols(int num);


		int rowNum() const{
			return matrix.size();
		}

		int colNum() const{
			if(matrix.empty())return 0;
			return matrix.front().size();
		}

		int sumOfElementArea(BoxSet& bset);
		std::vector<int> allBoxIndices();
		std::vector<int> allBoxIndices(std::vector<std::pair<int,int>>& matrixIndices);
		
		Box boundingbox(BoxSet& bset);

		bool isIntersectWith(Grid& grid,BoxSet& bset);
		bool isInFrontOf(Grid& grid,BoxSet& bset);
		std::vector<std::pair<int,int>> selectCells(Box& region,BoxSet& bset);
		Box cellBoundingBox(int r,int c,BoxSet&bset);
		void completeGrid(BoxSet& inBoxset,BoxSet &outBoxSet);
		void retargeting(int dim, int newSize,BoxSet& inBset,BoxSet &outSet);
		void print();
	};
}
#endif